// Consumer.h

#import <swarmobject/SwarmObject.h> // objects, in Swarm, import from 
                                    // SwarmObject
#import <simtools.h> // multiple function library, it also imports
                     // stdio.h
#import "Keeper.h"   // compulsory, because we are going to use a vendor
                     // list with keeper
#import "Vendor.h"  // required in order to use a vendor chosen from the list                     
#import "MeanPrice.h"// required to send messages to meanPrice                     
#import "ConsumerDescription.h" //required to send messages
                                // to consumerDescription
                     

@interface Consumer: SwarmObject {   // declaration of variables and
                                     // methods for the object Consumer, that
                                     // inherits the features of the more general
                                     // SwarmObject

  // object variables accessible from all its methods;
  // other variables may be declared within each method,
  // but they shall be valid only within that method.
  
  float level;     // price threshold below which the consumer buys
  int number;      // consumer's ID number
  int use_printf;  // when 0 printf is not used ; when 1, some; 2, all
  long time, numberOfTransactions;
                   // time (n. of the current loop) and n. of transactions                
  id vendorList;  // location (object pointer) of the vendor list

  id aVendor;    // location of a single vendor, from the list
//  Vendor * aVendor; // is the same
  id keeper;       // location of the object that draws out the first element 
                   // from a list and rotates the list.
                   
  float aPrice;    // price earned by a vendor
  float aMinPrice, aMaxPrice; // vendor's min and max, only aimed
                              // at plotting the graph
  id meanPrice;    // location of the object that computes the means
  id consumerDescription;
                   // location of the object that produces the graphical
                   // report of consumer's prices

  int memory;      // record on previous situation; it increases by 1 when
                   // it buys; it decreases by 1 if in a period it does not
                   // at the start  0
                   
  float minPrice, maxPrice; // required here in order to limit  
                            // upward and downward corrections of level                   
                   
}

// methods

-setNumber: (int) aNumber           // it indicates the consumer ID number
    andPrintf: (int) use_p;         // and whether it uses
                                    // or not printf
                                    // when 0 it does not; when 1, some; 
                                    // 2, all 
-setVendorList: (id) list;         // it identifies the location
                                    // of the object vendorList
-setKeeper: (id) o;                 // it identifies keeper, an object that
                                    // operates on the lists  
-setMeanPrice: (id) mP;             // it identifies meanPrice, the object 
                                    // that computes the means
-setConsumerDescription: (id) cD;   // it identifies consumerDescription,
                                    // the object aimed at the graphical
                                    // description of each consumer's price
-setTime: (long) startTime numberOfTransactionCounter: (long) initCounter; 
                               // it assigns the starting values for the time
                               // and pourchase counters
-setBuyLevel: (float) aLevel;  // it assigns the price threshold below which
                               // it buys
-negotiate;                    // it decides whether to buy
-reportStatistics;             // it generates the output for each agent's 
                               // statistics
                               
-(float) getPrice;             // it reports the aPrice price

-setMinPrice: (float) minP MaxPrice: (float) maxP;
                                    // min and maxPrice from modelSwarm
                                    

-setMemory;                    // it clears the consumer's memory

-updateLevel;                  // it updates memory and adjusts level 
                               // on the basis of the resulting value.

@end
