// Consumer.m

#import "Consumer.h"

@implementation Consumer    // implementation of the methods and description
                            // of local variables

-setNumber: (int) aNumber 
 andPrintf: (int) use_p {   // it sets the consumer's ID number
  number=aNumber;           // on the basis of the value from aNumber
  use_printf=use_p;         // and decides whether to write or not
                            // when 0 printf is not used ; when 1, some; 2, all
  return self;              
}

-setVendorList: (id) list {// it writes in vendorList the location that identifies
  vendorList = list;       // the vendors list 
  return self;
}

-setKeeper: o {             // it copies the location of the object keeper
  keeper=o;
  return self;
}

-setMeanPrice: mP {         // it copies at the local level the location of meanPrice
  meanPrice=mP;
  return self;
}

-setConsumerDescription: cD { // it copies at the local level the location of
  consumerDescription=cD;     //consumerDescription
  return self;
}

-setTime: (long) startTime numberOfTransactionCounter: (long) initCounter {
  time=startTime;                     // it sets the starting values for the time
  numberOfTransactions=initCounter;   // and the number of transactions
  return self;                        // for a particular object Consumer
}

-setBuyLevel: (float) aLevel {                 // it sets the threshold below which
  level=aLevel;                                // a particular object
if (use_printf==2)
printf("I'm consumer number%3d; my buying level is: %f\n",
                             number,level);  // buys; it generates also a
  return self;                               // message with this value
}

-negotiate {                           // it decides whether to buy
  time++;
  memory--;                            // it decreases the memory
  aVendor=[keeper keepFromList: vendorList];
  aPrice=[aVendor makeAnOffer];      // the local variable takes the
                                       // value of the offer
                                       // made by aVendor

  aMinPrice=[aVendor reportMinPrice];// min and max values
  aMaxPrice=[aVendor reportMaxPrice];// in order to plot the diagram

  [meanPrice addToGlobalMean: aPrice];

  [consumerDescription addAConsumer: number
   buyingLevel: level offerPrice: aPrice];    // it sends, indicating with number
                                              // its position,
                                              // the command to draw a
                                              // yellow zone
  [consumerDescription addPricesToConsumer: number
   buyingLevel: level offerPrice: aPrice      // in the same position it plots
                offerMinPrice: aMinPrice      // the vendor's price
                offerMaxPrice: aMaxPrice];    // and range
  if (aPrice <= level){
  [aVendor updateMemory: 1]; // it informs aVendor she has bought
  numberOfTransactions++; 
  memory+=2;                                  // if it buys, the net
                                              // increase in memory is +1
  [meanPrice addToTransactionMean: aPrice];
  if (use_printf>=1)
  printf("Agent #%2d (case %3ld); I'm buying at %5.2f from vendor #%2d\n",
        number,numberOfTransactions,aPrice,[aVendor reportNumber]);
                                       // it tells whether it has bought and from whom
                      }
  else  [aVendor updateMemory: 0]; // it tells aVendor it has not bought


  return self;
}

-reportStatistics {

  if( ((long) time) % 10 == 0)         // one time out of ten it generates the statistical
                                       // report (it uses the absolute value of the
                                       // integer division in order to make a decision)
  if (use_printf>=1)
  printf("Agent # %2d, time = %6ld, transaction # = %6ld\n",number,time,
                                                 numberOfTransactions);

  return self;
}

-(float) getPrice {
  return aPrice;
}

-setMinPrice: (float) minP MaxPrice: (float) maxP { // min and max prices
                                                    // from modelSwarm

  minPrice=minP;
  maxPrice=maxP;
  return self;
}

-setMemory {
  memory=0;
  return self;
}

-updateLevel {
  if (memory < -1) level+=2;
  if (memory >  1) level-=2;
  if (level < minPrice) level=minPrice;
  if (level > maxPrice) level=maxPrice;
  return self;
}

@end

