// ConsumerDescription.h

#import <space.h>  // it contains Discrete2d, an object that manages the id arrays
                   // (an integer may be used instead of an id)
                   // according to the documentation:
// The Discrete2d is essentially a 2d array of ids. However, we also allow 
// users to access the array as if it were an array of integers: the integers 
// are cast into ids for storage. The Object methods retrieve values as
// objects, the Value methods cast things to integers before returning. 
// We believe this is safe on all architectures. 
// - getObjectAtX: (int)x Y: (int)y 
//       Return the pointer stored at (x,y). 
// - getValueAtX: (int)x Y: (int)y 
//       Return the integer stored at (x,y). 
// - putObject: anObject atX: (int)x Y: (int)y 
//       Put the given pointer to (x,y) overwriting whatever was there. 
// - putValue: (int)v atX: (int)x Y: (int)y 
//       Put the given integer to (x,y) overwriting whatever was there.                    
                   
                   
#import <simtools.h>

@interface ConsumerDescription: Discrete2d {
  float minPrice, maxPrice;
}

-setMinPrice: (float) minP MaxPrice: (float) maxP;
                                    // min and maxPrice from modelSwarm 

-clear;                            // it clears everything

-addAConsumer: (int) number buyingLevel: (float) lev 
    offerPrice: (float) price;       // it adds the yellow or pink zone
                                     // that identifies a consumer
-addPricesToConsumer: (int) number buyingLevel: (float) lev 
                      offerPrice: (float) price 
                      offerMinPrice: (float) pMin offerMaxPrice: (float) pMax;
                                     // it adds the prices 

@end                    
