// ConsumerDescription.m

#import "ConsumerDescription.h"

@implementation ConsumerDescription

-setMinPrice: (float) minP MaxPrice: (float) maxP { // min and max price
                                                    // from modelSwarm

  minPrice=minP;
  maxPrice=maxP;
  return self;
}

-clear {  // all the array is filled with 0's (white on the
          // display)
 [self fillWithValue: 0];
 return self;
}

-addAConsumer: (int) number buyingLevel: (float) lev 
                    offerPrice: (float) price { // it adds the yellow or pink 
                                                // zone that identifies a
  int i, j, k;                                  // consumer 
  k=30*(number-1)-1+10;  // starting point on the x-axis in the yellow zone
  for (i=0;i<200;i++)    // for the consumer 'number'
  for (j=k;j<k+10;j++)
  if (price > lev) [self putValue: 11 atX: j Y: i];
     else          [self putValue: 12 atX: j Y: i]; 
  return self;
}

-addPricesToConsumer: (int) number buyingLevel: (float) lev 
                      offerPrice: (float) price 
                      offerMinPrice: (float) pMin 
                      offerMaxPrice: (float) pMax { // it adds prices
  int l, p, pMi, pMa, k, i, j;
  // on a height of 200, with a dot of 10 pixels, the whole scale
  // is from 0 to 190; starting from the bottom, with the origin up-left
  // it is from 199 to 9
  l=199-190*(lev-minPrice)/(maxPrice-minPrice);
  p=199-190*(price-minPrice)/(maxPrice-minPrice);
  pMi=199-190*(pMin-minPrice)/(maxPrice-minPrice);
  pMa=199-190*(pMax-minPrice)/(maxPrice-minPrice);

  k=30*(number-1)-1+10;  // starting position on the x-axis of the zone of
                         // the "dot" of 10 pixels
  for (j=k+7;j<k+10;j++)
  for (i=pMi;i>pMa-10;i--) [self putValue: 3 atX: j Y: i]; 
                                                     // 3=red, 
                                                     // vendor's price range
  for (j=k;j<k+10;j++){
  for (i=l;i>l-10;i--) [self putValue: 2 atX: j Y: i]; // 2=blue, level
  for (i=p;i>p-10;i--) [self putValue: 3 atX: j Y: i]; // 3=red,  price
  }
  return self;
}

@end                    
