// MeanPrice.h

#import <swarmobject/SwarmObject.h> // objects, in Swarm, import 
                                    // from SwarmObject
#import <simtools.h> // multiple function library, which also imports
                     // stdio.h
                     

@interface MeanPrice: SwarmObject {

  float globalMean;        // mean of all prices of a loop of 
                           // modelSchedule
  float transactionMean;   // mean of the prices that caused 
                           // transactions
  
  int   globalNumber;      // total number of prices
  int   transactionNumber; // number of transactions

  int   use_printf;        // when 0 printf is not used; when 1, some; 2, all
}

// methods

-setZero;                  // it sets to 0 all values

-usePrintf: (int) use_p;   // it sets use_printf
                           // when 0 printf is not used; when 1, some; 2, all

-addToGlobalMean:      (float) aPrice; // a price for the global mean

-addToTransactionMean: (float) aPrice; // a price for the transaction mean.

-findGlobalMean;               // it computes the global mean

-findTransactionMean;          // it computes the transaction mean

-(float) getGlobalMean;        // it reports  the global mean
-(float) getTransactionMean;   // idem

@end
