// ObserverSwarm.h

#import "ModelSwarm.h"

#import <swarmobject.h>
#import <space.h>
#import <activity.h>
#import <tkobjc.h>
#import <collections.h>
#import <simtools.h>
#import <analysis.h>

@interface ObserverSwarm : GUISwarm {
  int displayFrequency;                           // one parameter: update freq

  id displayActions;                              // schedule data structs

  id displaySchedule;

  ModelSwarm * modelSwarm;          		  // the Swarm we're observing

  id meanGraph;     // diagrams for the mean of prices
                    // will be managed via EZGraph, defined in analysis.h
  id mean2Graph;     // alternative way to draw, via EZGgraph, the over-all
                    // mean of prices

  XColormap * colorMap;  // map of the colours that will be used in 
                         // consumerRaster (Xcolormap comes from tkobj.h)
  Raster * consumerRaster;     // space to show the behaviour of prices
                               // for each consumer; (ZoomRaster
                               // comes from tkobj.h)
  Value2dDisplay * consumerDisplay;
                               // it plots an array of values in a Raster:
                               // see ObserverSwarm.m
                               // (it comes from space.h)


}

// Methods overriden to make the Swarm.

+createBegin: (id) aZone;       // in the main, aZone is globalZone
                                // it may be cancelled to verify the effect
                                // of a similar cancellation in ObserverSwarm.m
                                // see the remark there
-createEnd;

-buildObjects;
-buildActions;
-activateIn: (id) swarmContext; // in the main swarmContext corresponds to nil

@end

