// main.m					consumerObserver2.eco1

// capital remarks come from the tutorial from which I kept these
// files to modify them


#import "ObserverSwarm.h"

#import <simtools.h>                // ... FOR INITSWARM() 

// THE MAIN() FUNCTION IS THE TOP-LEVEL PLACE WHERE EVERYTHING STARTS.
// FOR A TYPICAL SWARM SIMULATION, IN MAIN() YOU CREATE A TOPLEVEL
// SWARM, LET IT BUILD AND ACTIVATE, AND SET IT TO RUNNING.

int main(int argc, char ** argv) {
  
  ObserverSwarm * observerSwarm;    // observerSwarm is an object of the kind
                                    // of ObserverSwarm (defined in
                                    // ObserverSwarm.h and .m), which in turn
                                    // inherits from GUISwarm

  // SWARM INITIALIZATION: ALL SWARM APPS MUST CALL THIS FIRST.

  initSwarm(argc, argv);            // with 1.0.3 release direct commands
                                    // operate, for example 
                                    // -varySeed to modify the random 
                                    // numbers seed, or -help

  // MAKE THE OBSERVER SWARM

  observerSwarm =  [ObserverSwarm create: globalZone]; // notice that here
                                                       // double create is not used

  // NOW SEND MESSAGES TO THE NEWLY CREATED SWARM TELLING IT
  // TO BUILD ITS INTERNAL OBJECTS AND ITS SCHEDULE.
  // THEN ACTIVATE THE SWARM.

  [observerSwarm buildObjects];
  [observerSwarm buildActions];
  [observerSwarm activateIn: nil];	// TOP-LEVEL SWARM IS ACTIVATED IN NIL
  
  // NOW THE SWARM IS BUILT, ACTIVATED, AND READY TO GO...

  // WE TELL THE SWARM ITSELF TO GO, INSTEAD OF AN ACTIVITY
  // BECAUSE THE OBSERVERSWARM IS A GUI-SWARM, AND HAS ITS
  // OWN CONTROLPANEL THAT WE CAN TALK TO.

  [observerSwarm go];

  // THE SWARM HAS FINISHED (TERMINATED), SO IT'S TIME TO QUIT

  return 0;

}


